#ifndef ___PAppSdlOpenGl3_H__
#define ___PAppSdlOpenGl3_H__


#define GL3_PROTOTYPES 1
#include <GL3/gl3.h>

#include <SDL2/SDL.h>
#include <SDL2/SDL_video.h>
#include <SDL2/SDL_keycode.h>
#include <SDL2/SDL_keyboard.h>
#include <SDL2/SDL_events.h>

#include <iostream>
#include <string>
#include <map>

#include "Matrice4.h"
#include "simple_camera_gl3.h"

typedef std::map<SDL_Keycode,bool> KeyStates;   //tableau de bool pour les évenements clavier
typedef std::map<std::string,SDL_Keycode> KeyConf; //tableau d'action pour savoir ce que l'utilisateur veut faire

/** @brief Classe qui permet de gérer simplement l'initialisation de SDL 1.3 et OpenGl 3.1,  les touches, les shaders, les programs OpenGl et on verra si on rajoute autre chose.
*/
class PAppSdlOpenGl3{
	public:
		PAppSdlOpenGl3(const std::string & titreFenetre, int largeurFenetre, int hauteurFenetre);
		virtual ~PAppSdlOpenGl3();
		
		int executer();
		bool isOpenGlSdlInit() const;
		void setFPS(Uint32 framePerSecond);
		
		float getRatio() const;
		
		void setPerpectiveDeg(float angleDeg, float near, float far);
		void setPerpectiveRad(float angleRad, float near, float far);
		void dontRun();
		
	protected:
		virtual void updateWithEvent(SDL_Event* event);
		virtual void update(float dt) = 0;
		virtual void draw3d() = 0;
		
		//rajoute un evenement clavier
		void addKeyEventRepeat(const std::string & action, SDL_Keycode key, bool initValue = false);
		
		///fonction qui dit si un évenement à tester s'est réalisé ou pas
		/**	@param action : nom de l'action à testé ("forward", "up", "down", "left", "right", "quit"...)
			@return true si la touche est pressée, false sinon
		*/
		inline bool keyEventMadeRepeat(const std::string & action){return p_keystatesRepeat[p_keyconfRepeat[action]];}
		
		//rajoute un evenement clavier
		void addKeyEventNoRepeat(const std::string & action, SDL_Keycode key, bool initValue = false);
		//evenement du clavier retourne true si action est réalisée
		///fonction qui dit si un évenement à tester s'est réalisé ou pas
		/**	@param action : nom de l'action à testé ("forward", "up", "down", "left", "right", "quit"...)
			@return true si la touche est pressée, false sinon
		*/
		inline bool keyEventMadeNoRepeat(const std::string & action){return p_keystatesNoRepeat[p_keyconfNoRepeat[action]];}
		void clearKeyStatesNoRepeat();
		void sendMatProjectionToShader(GLint idMatProjection);
		void sendMatModelViewToShader(GLint idMatModelView);
		void stop();
		
		Matrice4 p_matProjection;
		Matrice4 p_matModelview;
		///id de la fenêtre
		SDL_WindowID p_fenetre;
		///caméra de l'application
		SimpleCameraGl3 p_cameraGL;
		
	private:
		void initialisationPAppSdlOpenGl3(const std::string & titreFenetre, int largeurFenetre, int hauteurFenetre);
		PAppSdlOpenGl3(const PAppSdlOpenGl3 & other); //on met le constructeur de copie en private pour empêcher la copie de la classe
		//récupère les évenements du clavier
		void getEvent(SDL_Event* event);
		std::string p_titreFenetre;
		int p_largeurFenetre;
		int p_hauteurFenetre;

		SDL_GLContext p_contexteOpenGL;	
		SDL_Event p_evenements;
		bool p_isOpenGlSdlInit;
		bool p_isRun;
		
		///dernière mesure de temps de l'application (SDL_Ticks)
		Uint32 p_last_time; //dernière mesure de temps de l'application (SDL_Ticks)
		///temps courrant
		Uint32 p_current_time; //temps courrant
		///intervalle de temps entre le temps courrant et la dernière mesure de temps de l'application
		Uint32 p_ellapsed_time; //intervalle de temps entre le temps courrant et la dernière mesure de temps de l'application
		///instant ou l'appilcation a été déclenchée
		Uint32 p_start_time;   //instant ou l'appilcation a été déclenchée
		///tableau de bool pour les entrées clavier
		KeyStates p_keystatesRepeat; //tableau de bool pour les entrées clavier
		///association actions touches
		KeyConf p_keyconfRepeat;    //association actions touches
		///état dse touches qui ne se répètent pas (genre pour aller dans un menu)
		KeyStates p_keystatesNoRepeat;
		///config des touches qui ne se répètent pas
		KeyConf p_keyconfNoRepeat;
		///temps de rendu pour une frame
		Uint32 p_timeForOneFrame;
};


#endif //classe PAppSdlOpenGl3

